use clap::{crate_version, App, Arg};

pub fn build_cli() -> App<'static, 'static> {
    App::new("meowdict")
        .version(crate_version!())
        .author("Mag Mell")
        .about("Search chinese keyword from moedict.tw")
        .arg(
            Arg::with_name("INPUT")
                .help("Input the keyword to use")
                .index(1)
                .min_values(1),
        )
        .arg(
            Arg::with_name("translation")
                .short("t")
                .long("translation")
                .help("Get all translation")
                .requires("INPUT"),
        )
        .arg(
            Arg::with_name("jyutping")
                .short("j")
                .long("jyutping")
                .help("Get jyutping")
                .requires("INPUT")
                .conflicts_with("translation"),
        )
        .arg(
            Arg::with_name("inputs2t")
                .short("i")
                .long("input-s2t")
                .help("Convert input to traditional Chinese and search")
                .requires("INPUT"),
        )
        .arg(
            Arg::with_name("resultt2s")
                .short("r")
                .long("result-t2s")
                .help("Convert result to Simplified Chinese to display")
                .requires("INPUT"),
        )
        .arg(
            Arg::with_name("inputs2tmode")
                .long("input-s2t-mode")
                .help("Open console with input-s2t mode"),
        )
        .arg(
            Arg::with_name("resultt2smode")
                .long("result-t2s-mode")
                .help("Open console with result-t2s mode"),
        )
        .arg(
            Arg::with_name("no-color-output")
                .long("no-color-output")
                .help("Print result with no color")
                .requires("INPUT"),
        )
        .arg(
            Arg::with_name("json")
                .short("J")
                .long("json")
                .help("Print result to JSON output")
                .requires("INPUT"),
        )
}
